/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#include "qindividual.h"

using namespace ECWorkshop;

//////////////////////////////////////////////////////////
//
//		QIndividual class
//
///////////////////////////////////////////////////////////

QIndividual::QIndividual(void) : _niche(0) {
}

QIndividual::QIndividual (const QIndividual& argInd) {
	_params = argInd._params;
	_fitness = argInd._fitness;
	_niche = argInd._niche;
}

QIndividual::~QIndividual(void) {
}

QIndividual& QIndividual::operator = (const QIndividual& argInd) {
	_params = argInd._params;
	_fitness = argInd._fitness;
	_niche = argInd._niche;

	return (*this);
}

int QIndividual::assign (const QIndividual* argInd) {
	this->operator= ((QIndividual&)(*argInd));
	return Q_OK;
}

const QFitness& QIndividual::getFitness () const {
	return _fitness;
}

double QIndividual::getFitnessValue () const {
	return _fitness.getValue ();
}

int QIndividual::setFitness (const QFitness& argFitness) {
	_fitness = argFitness;
	return Q_OK;
}

int QIndividual::setFitness (const double argFitness) {
	_fitness = argFitness;
	return Q_OK;
}

int QIndividual::setNicheID (const unsigned int argN) {
	_niche = argN;
	return Q_OK;
}

unsigned int QIndividual::getNicheID () const {
	return _niche;
}

int QIndividual::setParameters (const QEAParameters* argParams) {
	_params = argParams;

	return createIndividual (_params->chromosomeLength);
}

