/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#include "qintegergene.h"

using namespace ECWorkshop;

///////////////////////////////////////////////////////////
//
//		QIntegerGene class
//
///////////////////////////////////////////////////////////

QIntegerGene::QIntegerGene (void) : _value (0) {
}

QIntegerGene::QIntegerGene (const QIntegerGene& argGene)
: QGene(argGene), _value(argGene._value) {
}

QIntegerGene::~QIntegerGene (void) {
}

QIntegerGene& QIntegerGene::operator = (const QIntegerGene& argGene) {
	_value = argGene._value;

	return (*this);
}

QGene* QIntegerGene::clone () const {
	return new QIntegerGene (*this);
}

QEncodingType QIntegerGene::getEncodingType () const {
	return QET_INTEGER;
}

bool QIntegerGene::equalsTo (const QGene* argGene) const {
	if (argGene->getEncodingType() == QET_INTEGER) {
		QIntegerGene* tempGene = (QIntegerGene*) argGene;
		return (_value == tempGene->_value)? true : false;
	} else {
		return false;
	}
}

int QIntegerGene::assign (const QGene* argGene) {
	if (argGene->getEncodingType() == QET_INTEGER) {
		_value = ((QIntegerGene*)argGene)->_value;
		return Q_OK;
	} else {
		return Q_FAILURE;
	}
}

int QIntegerGene::getValue () const {
	return _value;
}

int QIntegerGene::setValue (const int argValue) {
	_value = argValue;
	return Q_OK;
}


