/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#include "qrcgene.h"

using namespace ECWorkshop;

QRCGene::QRCGene (void)
: _value(0.0) {
}

QRCGene::QRCGene (const QRCGene& argGene)
: QGene(argGene), _value(argGene._value) {
}

QRCGene::~QRCGene (void) {
	_value = 0.0;
}

QRCGene& QRCGene::operator= (const QRCGene& argGene) {
	QGene::operator = (argGene);
	_value = argGene._value;
	return (*this);
}

QGene* QRCGene::clone () const {
	return new QRCGene (*this);
}

QEncodingType QRCGene::getEncodingType () const {
	return QET_REAL;
}

bool QRCGene::equalsTo (const QGene* argGene) const {
	if (argGene->getEncodingType() == QET_REAL) {
		double temp = ((QRCGene*)argGene)->_value;
		return (_value == temp)? true : false;
	} else {
		return false;
	}
}

int QRCGene::assign (const QGene* argGene) {
	if (argGene->getEncodingType() == QET_REAL) {
		_value = ((QRCGene*)argGene)->_value;
		return Q_OK;
	} else {
		return Q_FAILURE;
	}
}

double QRCGene::getValue () const {
	return _value;
}

int QRCGene::setValue (const double argValue) {
	_value = argValue;
	return Q_OK;
}


