/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		Q_REALCODE_INDIVIDUAL_H
#define		Q_REALCODE_INDIVIDUAL_H

#include "qindividual.h"
#include "qrcgene.h"

namespace ECWorkshop {

///////////////////////////////////////////////////////////
//
//		QRCIndividual class
//
///////////////////////////////////////////////////////////

class QRCIndividual : public QIndividual {
protected:

	__VECTOR_REALCODE_GENE _genes;
	virtual int createIndividual (const int argGenesNumber);

public:
	QRCIndividual (void);
	QRCIndividual (const QRCIndividual& argInd);
	virtual ~QRCIndividual(void);

	virtual QRCIndividual& operator= (const QRCIndividual& argInd);
	virtual int assign (const QIndividual* argInd);

	virtual int getSize () const;
	virtual int addGene (const QGene* argGene);
	virtual int deleteGene (const int argIndex);
	virtual QGene* getGene (const int argIndex);
	virtual const QGene* getGene (const int argIndex) const;
	virtual int setGene (const int argIndex, const QGene* argGene);
	virtual int clearIndividual ();
	virtual bool equalsTo (const QIndividual* argInd) const;

	virtual QIndividual* clone () const;

	virtual QEncodingType getEncodingType () const;
	virtual int toVectorDouble (__VECTOR_DOUBLE& target);
	virtual int toVectorInt (__VECTOR_INT& target);
	virtual int toVectorDouble (__VECTOR_DOUBLE& target) const;
	virtual int toVectorInt (__VECTOR_INT& target) const;

	virtual double getGeneValue (const int argIndex) const;
	virtual int setGeneValue (const int argIndex, const double argValue);

	virtual int print2Stream (ostream& out) const;
};

};	// namespace

#endif

