/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		Q_STRING_POPULATION_H
#define		Q_STRING_POPULATION_H

#include "qpopulation.h"
#include "qstringindividual.h"

namespace ECWorkshop {

///////////////////////////////////////////////////////////
//
//		QStringPopulation class
//
///////////////////////////////////////////////////////////

class QStringPopulation : public QPopulation {
protected:

	virtual int createPopulation (const int argSize);

public:

	QStringPopulation (void);
	QStringPopulation (const QStringPopulation& argPopul);
	virtual ~QStringPopulation (void);

	virtual QStringPopulation& operator= (const QStringPopulation& argPopul);

	virtual QEncodingType getEncodingType () const;
	virtual QPopulation* clone () const;
	// int addIndividual ()
	// Adds default individual to the end of population
	//	Returns new population size on success or Q_FAILURE otherwise
	virtual int addIndividual ();
};

};

#endif

