/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		OPERATORS_INCLUDE_H
#define		OPERATORS_INCLUDE_H

#include "qoperator.h"
#include "qeafactory.h"

#include "initialization/qinitializer.h"
#include "initialization/qintegerinitializer.h"
#include "initialization/qstringinitializer.h"
#include "initialization/qrcinitializer.h"
#include "initialization/qrninitializer.h"

#include "niching/qnichingoperator.h"
#include "niching/qfitnesssharing.h"

#include "selection/qselection.h"
#include "selection/qneutralselection.h"
#include "selection/qtournamentselection.h"

#include "crossover/qcrossover.h"
#include "crossover/qintegercrossover.h"
#include "crossover/qstringcrossover.h"
#include "crossover/qrccrossover.h"

#include "mutation/qmutation.h"
#include "mutation/qintegermutation.h"
#include "mutation/qstringmutation.h"
#include "mutation/qrcmutation.h"
#include "mutation/qrnmutation.h"

#include "populationsizer/qpopulationsizer.h"
#include "populationsizer/qconstpopulationsizer.h"
#include "populationsizer/qsteadypopulationsizer.h"
#include "populationsizer/qsimplepopulationsizer.h"
#include "populationsizer/qsimplepopulationsizerfibonacci.h"

#endif
