/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		Q_INTEGER_INITIALIZER_H
#define		Q_INTEGER_INITIALIZER_H

#include "qinitializer.h"

namespace ECWorkshop {

///////////////////////////////////////////////////////////
//
//		QIntegerInitializer class
//
///////////////////////////////////////////////////////////

class QIntegerInitializer : public QInitializer {
protected:
	double _unitsRatio;	// ratio of units for random initialization

	virtual int useRandom ();
	virtual int useUnmixed ();

	QIntegerInitializer (void);

public:
	QIntegerInitializer (const QEvolutionaryAlgorithm* owner);
	QIntegerInitializer (const QIntegerInitializer& argInit);
	virtual ~QIntegerInitializer (void);

	virtual int operate ();
	virtual QInitializer* clone () const;
	virtual QEncodingType getEncoding () const;

	virtual int setParameters (const QEAParameters& argParams);
};

};	// namespace

#endif

