/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		Q_REALCODE_INITIALIZER_H
#define		Q_REALCODE_INITIALIZER_H

#include "qinitializer.h"

namespace ECWorkshop {

///////////////////////////////////////////////////////////
//
//		QRCInitializer class
//
///////////////////////////////////////////////////////////

class QRCInitializer : public QInitializer {
protected:

	// random gaussian initialization
	virtual int useRandom ();
	virtual int useUnmixed ();

	QRCInitializer (void);

public:
	QRCInitializer (const QEvolutionaryAlgorithm* owner);
	QRCInitializer (const QRCInitializer& argInit);
	virtual ~QRCInitializer (void);

	virtual int operate ();
	virtual QInitializer* clone () const;
	virtual QEncodingType getEncoding () const;
};

};	// namespace

#endif


