/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#include "qparentselector.h"

using namespace ECWorkshop;

///////////////////////////////////////////////////////////
//
//		QParentSelector class
//
///////////////////////////////////////////////////////////

QParentSelector::QParentSelector(void)
: _parents(NULL) {
}

QParentSelector::QParentSelector (const QEvolutionaryAlgorithm* owner)
: QOperator(owner), _parents(NULL) {
}

QParentSelector::QParentSelector (const QParentSelector& argSelector):
QOperator(argSelector), _parents(argSelector._parents) {
}

QParentSelector::~QParentSelector(void) {
	_parents = NULL;
}

QParentSelector& QParentSelector::operator= (const QParentSelector& argSelector) {
	_parents = argSelector._parents;
	return (*this);
}

int QParentSelector::operate () {
	//
	// Should NEVER be called
	//

	// Do nothing and fail (just like our economists do)
	return Q_FAILURE;
}

int QParentSelector::setPopulation (const QPopulation* argParents) const {
	_parents = argParents;
	return Q_OK;
}
