/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#include "qconstpopulationsizer.h"

using namespace ECWorkshop;


///////////////////////////////////////////////////////////
//
//		QConstPopulationSizer class
//
///////////////////////////////////////////////////////////

QConstPopulationSizer::QConstPopulationSizer(void) {
}

QConstPopulationSizer::QConstPopulationSizer(const QEvolutionaryAlgorithm* owner)
: QPopulationSizer(owner) {
}

QConstPopulationSizer::QConstPopulationSizer (const QConstPopulationSizer& argSizer)
: QPopulationSizer(argSizer) {
}

QConstPopulationSizer::~QConstPopulationSizer(void) {
}

QConstPopulationSizer& QConstPopulationSizer::operator= (const QConstPopulationSizer& argSizer) {
	QPopulationSizer::operator = (argSizer);

	return (*this);
}

QPopulationSizer* QConstPopulationSizer::clone () const {
	return new QConstPopulationSizer (*this);
}

bool QConstPopulationSizer::populationReady () const {
	//assert (_popul != NULL);
	//cout<<"QConstPopulationSizer::populationReady\n";
	//cout.flush ();
	return (_popul->getSize() < _params->populationSize)? false : true; 
}

int QConstPopulationSizer::operate () {
	//assert (_popul != NULL);
	if (_popul->getSize() > _params->populationSize) {
		_popul->deleteIndividuals (_params->populationSize, _popul->getSize() - _params->populationSize);
	}
	return Q_OK;
}


