/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#include "qneutralselection.h"

using namespace ECWorkshop;

///////////////////////////////////////////////////////////
//
//		QNeutralSelection class
//
///////////////////////////////////////////////////////////

QNeutralSelection::QNeutralSelection (void) {
}

QNeutralSelection::QNeutralSelection (const QEvolutionaryAlgorithm* owner)
: QSelection(owner) {
}

QNeutralSelection::QNeutralSelection (const QNeutralSelection& argSelection)
: QSelection(argSelection) {
}

QNeutralSelection::~QNeutralSelection (void) {
}

int QNeutralSelection::operate () {
//	assert (_popul != NULL);
//	assert (_selPopul != NULL);

//	_selPopul->assign (_popul);
	_selPopul->clearPopulation();
	int size = _popul->getSize();
	for (int i=0; i<size; i++) {
		_selPopul->addIndividual( _popul->getIndividual( (int)(QRandN() *  size)));
	}
	return Q_OK;
}

QSelection* QNeutralSelection::clone () const {
	return new QNeutralSelection (*this);
}



