/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#include "qselection.h"


using namespace ECWorkshop;

///////////////////////////////////////////////////////////
//
//		QSelection class
//
///////////////////////////////////////////////////////////

QSelection::QSelection (void)
: _popul(NULL), _selPopul(NULL) {
}

QSelection::QSelection (const QEvolutionaryAlgorithm* owner)
: QOperator(owner), _popul(NULL), _selPopul(NULL) {
}

QSelection::QSelection (const QSelection& argSelection)
: QOperator(argSelection), _popul(argSelection._popul), _selPopul(argSelection._selPopul) {
}

QSelection::~QSelection (void) {
	_popul = _selPopul = NULL;
}

int QSelection::setPopulations (const QPopulation* argPopul, QPopulation * argSelPopul) {
	//assert (argPopul != NULL);
	//assert (argSelPopul != NULL);

	_popul = argPopul;
	_selPopul = argSelPopul;

	return Q_OK;
}
