/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		Q_SELECTION_H
#define		Q_SELECTION_H

#include "../qoperator.h"

#include "../../encodings/qpopulation.h"

namespace ECWorkshop {

///////////////////////////////////////////////////////////
//
//		QSelection class
//
///////////////////////////////////////////////////////////

class QSelection : public QOperator {
protected:

	const QPopulation * _popul;	// source population
	QPopulation* _selPopul;		// target population

	QSelection (void);

public:

	QSelection (const QEvolutionaryAlgorithm* owner);
	QSelection (const QSelection& argSelection);
	virtual ~QSelection (void);

	virtual QSelection* clone () const = 0;

	virtual int setPopulations (const QPopulation* argPopul, QPopulation * argSelPopul);
};

typedef vector<QSelection*>		__VECTOR_SELECTION_PTR;

};	// namespace

#endif


