/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#include "qtournamentselection.h"

using namespace ECWorkshop;

///////////////////////////////////////////////////////////
//
//		QTournamentSelection class
//
///////////////////////////////////////////////////////////

QTournamentSelection::QTournamentSelection (void) {
}

QTournamentSelection::QTournamentSelection (const QEvolutionaryAlgorithm* owner)
: QSelection(owner) {
}

QTournamentSelection::QTournamentSelection (const QTournamentSelection& argSelection)
: QSelection(argSelection) {
}

QTournamentSelection::~QTournamentSelection (void) {
}

QSelection* QTournamentSelection::clone () const {
	return new QTournamentSelection(*this);
}

int QTournamentSelection::operate () {
	//assert (_popul != NULL);
	//assert (_selPopul != NULL);

	__VECTOR_CONST_INDIVIDUAL_PTR tour;
	double minFitness;
	int minFitnessIndex;
	int i, j;

	_selPopul->clearPopulation ();
	for (i=0; i<_popul->getSize(); i++) {
		// define tournament
		tour.clear ();
		tour.push_back (_popul->getIndividual ( (int)(QRandN()*_popul->getSize()) ));
		minFitness = tour[0]->getFitnessValue ();
		minFitnessIndex = 0;
		for (j=1; j<_params->tournamentSize; j++) {
			tour.push_back (_popul->getIndividual ( (int)(QRandN()*_popul->getSize()) ));
			if (minFitness > tour[j]->getFitnessValue()) {
				minFitness = tour[j]->getFitnessValue();
				minFitnessIndex = j;
			}
		}

		_selPopul->addIndividual (tour [minFitnessIndex]);
	}

	return Q_OK;
}
