/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#include "qpointlessproblem.h"

using namespace ECWorkshop;

///////////////////////////////////////////////////////////
//
//		QPointlessProblem class
//
///////////////////////////////////////////////////////////

QPointlessProblem::QPointlessProblem (void) {
}

QPointlessProblem::~QPointlessProblem (void) {
}

int QPointlessProblem::evaluateIndividual (QIndividual* argInd) {
	argInd->setFitness (QRandN ());

	return Q_OK;
}

int QPointlessProblem::evaluatePopulation (QPopulation* argPopul) {
	int i, popSize = argPopul->getSize ();

	for (i=0; i<popSize; i++) {
		evaluateIndividual (argPopul->getIndividual( i ));
	}

	return Q_OK;
}

int QPointlessProblem::getDefaultParameters (QEAParameters* argParams) {
	return Q_OK;
}

int QPointlessProblem::printProblemName (ostream& out) {
	out<<"Pointless problem\n";
	return Q_OK;
}
