/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		Q_SUMMARY_PROCESSOR
#define		Q_SUMMARY_PROCESSOR

#include "../include/qec.h"
#include "../include/qrunsummary.h"

namespace ECWorkshop {

///////////////////////////////////////////////////////////
//
//		QSummaryProcessor class
//
// Notes:
// --------
// Class to process data from multiple runs of EA
// Summary to process is added using [addSummary] method
//
///////////////////////////////////////////////////////////

class QSummaryProcessor {
protected:
	__VECTOR_RUN_SUMMARY _summaries;
	const QEAParameters* _params;

	virtual int printParameters (ostream& out);

public:

	QSummaryProcessor(void);
	virtual ~QSummaryProcessor(void);

	int setParameters (const QEAParameters* argParams);

	// int clear ()
	//  Deletes all summaries
	//virtual int clear ();
	virtual int addSummary (const QRunSummary& argSummary);
	virtual int getSummariesNumber ();

	virtual int operate ();
};

};	// namespace

#endif
